﻿using Buddy.Coroutines;
using ff14bot;
using ff14bot.Managers;
using System.Threading.Tasks;
using UltimaCR.Spells.Main;

namespace UltimaCR.Rotations
{
    public sealed partial class Bard
    {
        private BardSpells _mySpells;

        private BardSpells MySpells
        {
            get { return _mySpells ?? (_mySpells = new BardSpells()); }
        }

        #region Class Spells

        private async Task<bool> HeavyShot()
        {
            if (!Actionmanager.HasSpell(MySpells.EmpyrealArrow.Name) ||
		!Actionmanager.HasSpell(MySpells.EmpyrealArrow.Name) &&
		Core.Player.HasAura(128) ||
		Actionmanager.HasSpell(MySpells.EmpyrealArrow.Name) &&
		!Actionmanager.CanCast(MySpells.EmpyrealArrow.Name, Core.Player.CurrentTarget) &&
		!Core.Player.HasAura(128))
            {
                return await MySpells.HeavyShot.Cast();
            }
            return false;
        }

        private async Task<bool> StraightShot()
        {
            if (Ultima.LastSpell.Name != MySpells.StraightShot.Name &&
		!Core.Player.HasAura(128))
            {
                if (!Core.Player.HasAura(865) &&
                    Core.Player.HasAura("Straighter Shot") ||

		    !Core.Player.HasAura(865) &&
		    !Core.Player.HasAura(MySpells.StraightShot.Name, true, 3350) ||

		    !Core.Player.InCombat &&
		    !Actionmanager.HasSpell(MySpells.IronJaws.Name) &&
		    Core.Player.HasAura(865) &&
		    !Core.Player.HasAura(MySpells.StraightShot.Name, true, 4250) ||

		    !Core.Player.InCombat &&
		    Actionmanager.HasSpell(MySpells.IronJaws.Name) &&
		    Core.Player.HasAura(865) &&
		    !Core.Player.HasAura(MySpells.StraightShot.Name, true, 4250) ||

		    Core.Player.InCombat &&
		    !Actionmanager.HasSpell(MySpells.IronJaws.Name) &&
		    Core.Player.HasAura(865) &&
		    !Core.Player.HasAura(MySpells.StraightShot.Name, true, 4250) ||

		    Core.Player.InCombat &&
		    Actionmanager.HasSpell(MySpells.IronJaws.Name) &&
		    Core.Player.HasAura(865) &&
		    !Core.Player.HasAura(MySpells.StraightShot.Name, true, 4250))
                {
                    return await MySpells.StraightShot.Cast();
		}
            }
            return false;
        }

        private async Task<bool> StraighterShotWMspec()
        {
            if (Ultima.LastSpell.Name != MySpells.StraightShot.Name &&
		!Core.Player.HasAura(128) &&
		Core.Player.HasAura(865) &&
                Core.Player.HasAura("Straighter Shot"))
            {
                if (Core.Player.CurrentTarget.HasAura(MySpells.VenomousBite.Name, true, 5250) &&
                    Core.Player.CurrentTarget.HasAura(MySpells.Windbite.Name, true, 5250) ||

		    !Core.Player.CurrentTarget.HasAura(MySpells.VenomousBite.Name, true) &&
                    !Core.Player.CurrentTarget.HasAura(MySpells.Windbite.Name, true))
                {
                    return await MySpells.StraightShot.Cast();
		}
            }
            return false;
        }

        private async Task<bool> RaidRagingStrikes()
        {
            if (Actionmanager.CanCast(MySpells.Barrage.Name, Core.Player) &&
		Core.Player.CurrentTarget.CurrentHealthPercent >= 92 &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 10 &&
		Core.Player.HasTarget)
            {
                return await MySpells.RagingStrikes.Cast();
            }
            return false;
        }

        private async Task<bool> RagingStrikes()
        {
            if (Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Core.Player.TargetDistance(25, false) &&
		Ultima.LastSpell.Name != MySpells.CrossClass.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.HawksEye.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.FoeRequiem.Name &&
		Ultima.LastSpell.Name != MySpells.Sidewinder.Name &&
		Ultima.LastSpell.Name != MySpells.RainOfDeath.Name &&
		Ultima.LastSpell.Name != MySpells.Bloodletter.Name &&
		Ultima.LastSpell.Name != MySpells.RepellingShot.Name &&
		Ultima.LastSpell.Name != MySpells.BluntArrow.Name &&
		Ultima.LastSpell.Name != MySpells.FlamingArrow.Name)
            {
                if (Ultima.UltSettings.SmartTarget &&
		    Helpers.EnemiesNearTarget(8) > 5 &&
		    Core.Player.CurrentTarget.CurrentHealthPercent > 70 ||

		    Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth &&
		    Core.Player.CurrentTarget.CurrentHealthPercent > 70 ||

		    Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth)
                {
                    return await MySpells.RagingStrikes.Cast();
		}
            }
            return false;
        }

        private async Task<bool> RaidVenomousBite()
        {
            if (Core.Player.CurrentTarget.CurrentHealthPercent >= 92 &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 10 &&
		Ultima.LastSpell.Name != MySpells.VenomousBite.Name &&
		!Core.Player.HasAura(128) &&
		!Core.Player.CurrentTarget.HasAura(MySpells.VenomousBite.Name, true) &&
		!Actionmanager.CanCast(MySpells.RagingStrikes.Name, Core.Player) &&
		!Actionmanager.CanCast(MySpells.HawksEye.Name, Core.Player) &&
		!Actionmanager.CanCast(MySpells.CrossClass.BloodForBlood.Name, Core.Player) &&
		!Actionmanager.CanCast(MySpells.CrossClass.InternalRelease.Name, Core.Player))
            {
                return await MySpells.VenomousBite.Cast();
            }
            return false;
        }

        private async Task<bool> VenomousBite()
        {
            if (Ultima.LastSpell.Name != MySpells.VenomousBite.Name &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth / 2 &&
		!Core.Player.HasAura(128) &&
		!Core.Player.HasAura(865) &&
		!Core.Player.CurrentTarget.HasAura(MySpells.VenomousBite.Name, true, 3350) ||

		Ultima.LastSpell.Name != MySpells.VenomousBite.Name &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth / 2 &&
		!Core.Player.HasAura(128) &&
		Core.Player.HasAura(865) &&
		!Core.Player.CurrentTarget.HasAura(MySpells.VenomousBite.Name, true, 4000))
            {
                return await MySpells.VenomousBite.Cast();
            }
            return false;
        }

        private async Task<bool> RaidWindbite()
        {
            if (Core.Player.CurrentTarget.CurrentHealthPercent >= 92 &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 10 &&
		Ultima.LastSpell.Name != MySpells.Windbite.Name &&
		!Core.Player.HasAura(128) &&
		!Core.Player.CurrentTarget.HasAura(MySpells.Windbite.Name, true) &&
		!Actionmanager.CanCast(MySpells.RagingStrikes.Name, Core.Player) &&
		!Actionmanager.CanCast(MySpells.HawksEye.Name, Core.Player) &&
		!Actionmanager.CanCast(MySpells.CrossClass.BloodForBlood.Name, Core.Player) &&
		!Actionmanager.CanCast(MySpells.CrossClass.InternalRelease.Name, Core.Player))
            {
                return await MySpells.Windbite.Cast();
            }
            return false;
        }

        private async Task<bool> Windbite()
        {
            if (Ultima.LastSpell.Name != MySpells.Windbite.Name &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth &&
		!Core.Player.HasAura(128) &&
		!Core.Player.HasAura(865) &&
		!Core.Player.CurrentTarget.HasAura(MySpells.Windbite.Name, true, 3350) ||
		
		Ultima.LastSpell.Name != MySpells.Windbite.Name &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth &&
		!Core.Player.HasAura(128) &&
		Core.Player.HasAura(865) &&
		!Core.Player.CurrentTarget.HasAura(MySpells.Windbite.Name, true, 4000))
            {
                return await MySpells.Windbite.Cast();
            }
            return false;
        }

        private async Task<bool> MiserysEnd()
        {
            if (Ultima.UltSettings.BardMiserysEnd &&
		Ultima.LastSpell.Name != MySpells.CrossClass.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.HawksEye.Name &&
		Ultima.LastSpell.Name != MySpells.RagingStrikes.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.FoeRequiem.Name &&
		Ultima.LastSpell.Name != MySpells.Sidewinder.Name &&
		Ultima.LastSpell.Name != MySpells.RainOfDeath.Name &&
		Ultima.LastSpell.Name != MySpells.Bloodletter.Name &&
		Ultima.LastSpell.Name != MySpells.RepellingShot.Name &&
		Ultima.LastSpell.Name != MySpells.BluntArrow.Name &&
		Ultima.LastSpell.Name != MySpells.FlamingArrow.Name)
            {
                return await MySpells.MiserysEnd.Cast();
            }
            return false;
        }
 
        private async Task<bool> Shadowbind()
        {
            return await MySpells.Shadowbind.Cast();
        }

        private async Task<bool> Bloodletter()
        {
            if (Ultima.LastSpell.Name != MySpells.CrossClass.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.HawksEye.Name &&
		Ultima.LastSpell.Name != MySpells.RagingStrikes.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.FoeRequiem.Name &&
		Ultima.LastSpell.Name != MySpells.MiserysEnd.Name &&
		Ultima.LastSpell.Name != MySpells.Sidewinder.Name &&
		Ultima.LastSpell.Name != MySpells.RainOfDeath.Name &&
		Ultima.LastSpell.Name != MySpells.RepellingShot.Name &&
		Ultima.LastSpell.Name != MySpells.BluntArrow.Name &&
		Ultima.LastSpell.Name != MySpells.FlamingArrow.Name)
            {
                return await MySpells.Bloodletter.Cast();
            }
            return false;
        }
 
        private async Task<bool> RepellingShot()
        {
            if (Core.Player.TargetDistance(5, false) &&
		Ultima.LastSpell.Name != MySpells.CrossClass.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.HawksEye.Name &&
		Ultima.LastSpell.Name != MySpells.RagingStrikes.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.FoeRequiem.Name &&
		Ultima.LastSpell.Name != MySpells.MiserysEnd.Name &&
		Ultima.LastSpell.Name != MySpells.Sidewinder.Name &&
		Ultima.LastSpell.Name != MySpells.RainOfDeath.Name &&
		Ultima.LastSpell.Name != MySpells.Bloodletter.Name &&
		Ultima.LastSpell.Name != MySpells.BluntArrow.Name &&
		Ultima.LastSpell.Name != MySpells.FlamingArrow.Name)
            {
                return await MySpells.RepellingShot.Cast();
            }
            return false;
        }

        private async Task<bool> QuickNock()
        {
            if (!Core.Player.HasAura(128) &&
		Helpers.EnemiesNearTarget(8) > 2)
            {
                return await MySpells.QuickNock.Cast();
            }
            return false;
        }

        private async Task<bool> Swiftsong()
        {
            if (!Ultima.UltSettings.MultiTarget &&
		!MovementManager.IsMoving &&
		Helpers.EnemiesNearPlayer(25) == 0 &&
		!Core.Player.HasTarget &&
		!Core.Player.InCombat &&
                !Core.Player.HasAura(MySpells.Swiftsong.Name))
            {
                return await MySpells.Swiftsong.Cast();
            }
            return false;
        }

        private async Task<bool> RaidHawksEye()
        {
            if (Actionmanager.CanCast(MySpells.Barrage.Name, Core.Player) &&
		Core.Player.CurrentTarget.CurrentHealthPercent >= 92 &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 10 &&
		Core.Player.HasTarget)
            {
                return await MySpells.HawksEye.Cast();
            }
            return false;
        }

        private async Task<bool> HawksEye()
        {
            if (Core.Player.CurrentTarget.CurrentHealthPercent < 92 &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Core.Player.TargetDistance(25, false) &&
		Ultima.LastSpell.Name != MySpells.CrossClass.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.RagingStrikes.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.FoeRequiem.Name &&
		Ultima.LastSpell.Name != MySpells.MiserysEnd.Name &&
		Ultima.LastSpell.Name != MySpells.Sidewinder.Name &&
		Ultima.LastSpell.Name != MySpells.RainOfDeath.Name &&
		Ultima.LastSpell.Name != MySpells.Bloodletter.Name &&
		Ultima.LastSpell.Name != MySpells.RepellingShot.Name &&
		Ultima.LastSpell.Name != MySpells.BluntArrow.Name &&
		Ultima.LastSpell.Name != MySpells.FlamingArrow.Name)
            {
                if (Ultima.UltSettings.SmartTarget &&
		    Helpers.EnemiesNearTarget(8) > 5 &&
		    Core.Player.CurrentTarget.CurrentHealthPercent > 70 ||

		    Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth &&
		    Core.Player.CurrentTarget.CurrentHealthPercent > 70 ||

		    Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth)
                {
                    return await MySpells.HawksEye.Cast();
		}
            }
            return false;
        }

        private async Task<bool> QuellingStrikes()
        {
            return await MySpells.QuellingStrikes.Cast();
        }

        private async Task<bool> Barrage()
        {
            if (Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth &&
		Core.Player.CurrentTarget.CurrentHealthPercent > 70 &&
		!Actionmanager.HasSpell(MySpells.EmpyrealArrow.Name) &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Core.Player.CurrentTarget.HasAura(MySpells.VenomousBite.Name, true, 4000) ||

		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth &&
		!Actionmanager.HasSpell(MySpells.EmpyrealArrow.Name) &&
		!Actionmanager.CanCast(MySpells.RagingStrikes.Name, Core.Player) &&
		!Actionmanager.CanCast(MySpells.HawksEye.Name, Core.Player) &&
		!Actionmanager.CanCast(MySpells.CrossClass.BloodForBlood.Name, Core.Player) &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Core.Player.CurrentTarget.HasAura(MySpells.VenomousBite.Name, true, 4000) &&
		Core.Player.CurrentTarget.HasAura(MySpells.Windbite.Name, true, 4000))
            {
                return await MySpells.Barrage.Cast();
            }
            return false;
        }

        private async Task<bool> BluntArrow()
	{
            if (Ultima.UltSettings.BardBluntArrow &&
		Ultima.LastSpell.Name != MySpells.CrossClass.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.HawksEye.Name &&
		Ultima.LastSpell.Name != MySpells.RagingStrikes.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.FoeRequiem.Name &&
		Ultima.LastSpell.Name != MySpells.MiserysEnd.Name &&
		Ultima.LastSpell.Name != MySpells.Sidewinder.Name &&
		Ultima.LastSpell.Name != MySpells.RainOfDeath.Name &&
		Ultima.LastSpell.Name != MySpells.Bloodletter.Name &&
		Ultima.LastSpell.Name != MySpells.RepellingShot.Name &&
		Ultima.LastSpell.Name != MySpells.FlamingArrow.Name)
		
            {
                if (Core.Player.InCombat &&
		    Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth * 3 ||

    		    !Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 3 &&
		    Core.Player.CurrentTarget.HasAura(MySpells.VenomousBite.Name, true) &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Windbite.Name, true) ||

		    Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 3 &&
		    Core.Player.CurrentTarget.HasAura(MySpells.VenomousBite.Name, true) &&
		    Core.Player.CurrentTarget.HasAura(MySpells.Windbite.Name, true) &&
		    !Actionmanager.CanCast(MySpells.RagingStrikes.Name, Core.Player) &&
		    !Actionmanager.CanCast(MySpells.HawksEye.Name, Core.Player) &&
		    !Actionmanager.CanCast(MySpells.CrossClass.BloodForBlood.Name, Core.Player) &&
		    !Actionmanager.CanCast(MySpells.CrossClass.InternalRelease.Name, Core.Player))
                {
                    return await MySpells.BluntArrow.Cast();
		}
            }
            return false;
        }

        private async Task<bool> FlamingArrow()
        {
            if (Ultima.UltSettings.BardFlamingArrow &&
		!MovementManager.IsMoving &&
		Ultima.LastSpell.Name != MySpells.CrossClass.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.HawksEye.Name &&
		Ultima.LastSpell.Name != MySpells.RagingStrikes.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.FoeRequiem.Name &&
		Ultima.LastSpell.Name != MySpells.MiserysEnd.Name &&
		Ultima.LastSpell.Name != MySpells.Sidewinder.Name &&
		Ultima.LastSpell.Name != MySpells.RainOfDeath.Name &&
		Ultima.LastSpell.Name != MySpells.Bloodletter.Name &&
		Ultima.LastSpell.Name != MySpells.RepellingShot.Name &&
		Ultima.LastSpell.Name != MySpells.BluntArrow.Name &&
		Core.Player.TargetDistance(20, false))
		
            {
                if (Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 10 &&
		    Core.Player.CurrentTarget.CurrentHealthPercent > 7 ||

		    Ultima.UltSettings.SmartTarget &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth &&
		    Helpers.EnemiesNearTarget(8) > 1)
                {
                    return await MySpells.FlamingArrow.Cast();
		}
            }
            return false;
        }

        private async Task<bool> WideVolley()
        {
            return await MySpells.WideVolley.Cast();
        }

        #endregion

        #region Cross Class Spells

        #region Lancer

        private async Task<bool> Feint()
        {
            if (Ultima.UltSettings.BardMiserysEnd &&
		Actionmanager.CanCast(MySpells.MiserysEnd.Name, Core.Player.CurrentTarget)  ||
		Actionmanager.CanCast(MySpells.Bloodletter.Name, Core.Player.CurrentTarget)  ||
		Ultima.UltSettings.BardBluntArrow &&
		Actionmanager.CanCast(MySpells.BluntArrow.Name, Core.Player.CurrentTarget) ||
		Actionmanager.CanCast(MySpells.Sidewinder.Name, Core.Player.CurrentTarget))
		
            {
                if (Ultima.UltSettings.BardFeint &&
		    MovementManager.IsMoving &&
		    Core.Player.HasAura(865) &&
		    !Core.Player.HasAura(128) &&
		    Ultima.LastSpell.Name != MySpells.Barrage.Name &&
		    Ultima.LastSpell.Name != MySpells.RepellingShot.Name &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth &&
		    Core.Player.CurrentTarget.HasAura(MySpells.VenomousBite.Name, true, 7500) &&
                    Core.Player.CurrentTarget.HasAura(MySpells.Windbite.Name, true, 7500) ||

		    Ultima.UltSettings.BardFeint &&
		    MovementManager.IsMoving &&
		    Core.Player.HasAura(865) &&
		    !Core.Player.HasAura(128) &&
		    Ultima.LastSpell.Name != MySpells.Barrage.Name &&
		    Ultima.LastSpell.Name != MySpells.RepellingShot.Name &&		
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth &&
		    !Core.Player.CurrentTarget.HasAura(MySpells.VenomousBite.Name) &&
                    !Core.Player.CurrentTarget.HasAura(MySpells.Windbite.Name) ||

		    Ultima.UltSettings.BardFeint &&
		    MovementManager.IsMoving &&
		    Core.Player.HasAura(865) &&
		    !Core.Player.HasAura(128) &&
		    Ultima.LastSpell.Name != MySpells.Barrage.Name &&
		    Ultima.LastSpell.Name != MySpells.RepellingShot.Name &&
		    Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth)
                {
                    return await MySpells.CrossClass.Feint.Cast();
		}
            }
            return false;
        }

        private async Task<bool> KeenFlurry()
        {
            if (Ultima.UltSettings.BardKeenFlurry)
            {
                return await MySpells.CrossClass.KeenFlurry.Cast();
            }
            return false;
        }

        private async Task<bool> Invigorate()
        {
            if (Ultima.UltSettings.BardInvigorate &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
                Core.Player.CurrentTP < 540 &&
		Ultima.LastSpell.Name != MySpells.HawksEye.Name &&
		Ultima.LastSpell.Name != MySpells.RagingStrikes.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.FoeRequiem.Name &&
		Ultima.LastSpell.Name != MySpells.MiserysEnd.Name &&
		Ultima.LastSpell.Name != MySpells.Sidewinder.Name &&
		Ultima.LastSpell.Name != MySpells.RainOfDeath.Name &&
		Ultima.LastSpell.Name != MySpells.Bloodletter.Name &&
		Ultima.LastSpell.Name != MySpells.RepellingShot.Name &&
		Ultima.LastSpell.Name != MySpells.BluntArrow.Name &&
		Ultima.LastSpell.Name != MySpells.FlamingArrow.Name)
            {
                if (Ultima.UltSettings.SmartTarget &&
		    Helpers.EnemiesNearTarget(8) > 2 &&
		    Core.Player.CurrentTarget.CurrentHealthPercent > 40 ||
		
		    !Ultima.UltSettings.SmartTarget &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2)
                {
                    return await MySpells.CrossClass.Invigorate.Cast();
		}
            }
            return false;
        }

        private async Task<bool> RaidBloodForBlood()
        {
            if (Actionmanager.CanCast(MySpells.Barrage.Name, Core.Player) &&
		Core.Player.CurrentTarget.CurrentHealthPercent >= 92 &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 10 &&
		Core.Player.HasTarget)
            {
                return await MySpells.CrossClass.BloodForBlood.Cast();
            }
            return false;
        }

        private async Task<bool> BloodForBlood()
        {
            if (Ultima.UltSettings.BardBloodForBlood &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Core.Player.TargetDistance(25, false) &&
		Ultima.LastSpell.Name != MySpells.CrossClass.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.HawksEye.Name &&
		Ultima.LastSpell.Name != MySpells.RagingStrikes.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.FoeRequiem.Name &&
		Ultima.LastSpell.Name != MySpells.MiserysEnd.Name &&
		Ultima.LastSpell.Name != MySpells.Sidewinder.Name &&
		Ultima.LastSpell.Name != MySpells.RainOfDeath.Name &&
		Ultima.LastSpell.Name != MySpells.Bloodletter.Name &&
		Ultima.LastSpell.Name != MySpells.RepellingShot.Name &&
		Ultima.LastSpell.Name != MySpells.BluntArrow.Name &&
		Ultima.LastSpell.Name != MySpells.FlamingArrow.Name)
            {
                if (Ultima.UltSettings.SmartTarget &&
		    Helpers.EnemiesNearTarget(8) > 5 &&
		    Core.Player.CurrentTarget.CurrentHealthPercent > 70 ||

		    Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth &&
		    Core.Player.CurrentTarget.CurrentHealthPercent > 70 ||

		    Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth)
                {
                    return await MySpells.CrossClass.BloodForBlood.Cast();
		}
            }
            return false;
        }

        #endregion

        #region Pugilist

        private async Task<bool> Featherfoot()
        {
            if (Ultima.UltSettings.BardFeatherfoot)
            {
                return await MySpells.CrossClass.Featherfoot.Cast();
            }
            return false;
        }

        private async Task<bool> SecondWind()
        {
            if (Core.Player.InCombat &&
		Core.Player.CurrentHealthPercent <= 40 ||
		
		Core.Player.CurrentTarget.IsFacing(Core.Player) &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Core.Player.TargetDistance(4, false) &&
		Core.Player.CurrentHealthPercent <= 60)
            {
                return await MySpells.CrossClass.SecondWind.Cast();
            }
            return false;
        }

        private async Task<bool> Haymaker()
        {
            if (Ultima.UltSettings.BardHaymaker)
            {
                return await MySpells.CrossClass.Haymaker.Cast();
            }
            return false;
        }

        private async Task<bool> RaidInternalRelease()
        {
            if (Actionmanager.CanCast(MySpells.Barrage.Name, Core.Player) &&
		Core.Player.CurrentTarget.CurrentHealthPercent >= 92 &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 10 &&
		Core.Player.HasTarget)
            {
                return await MySpells.CrossClass.InternalRelease.Cast();
            }
            return false;
        }

        private async Task<bool> InternalRelease()
        {
            if (Ultima.UltSettings.BardInternalRelease &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Core.Player.TargetDistance(25, false) &&
		Ultima.LastSpell.Name != MySpells.CrossClass.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.HawksEye.Name &&
		Ultima.LastSpell.Name != MySpells.RagingStrikes.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.FoeRequiem.Name &&
		Ultima.LastSpell.Name != MySpells.MiserysEnd.Name &&
		Ultima.LastSpell.Name != MySpells.Sidewinder.Name &&
		Ultima.LastSpell.Name != MySpells.RainOfDeath.Name &&
		Ultima.LastSpell.Name != MySpells.Bloodletter.Name &&
		Ultima.LastSpell.Name != MySpells.RepellingShot.Name &&
		Ultima.LastSpell.Name != MySpells.BluntArrow.Name &&
		Ultima.LastSpell.Name != MySpells.FlamingArrow.Name)
            {
                if (Ultima.UltSettings.SmartTarget &&
		    Helpers.EnemiesNearTarget(8) > 5 &&
		    Core.Player.CurrentTarget.CurrentHealthPercent > 70 ||
		    
		    Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth &&
		    Core.Player.CurrentTarget.CurrentHealthPercent > 70 ||

		    Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth)
                {
                    return await MySpells.CrossClass.InternalRelease.Cast();
		}
            }
            return false;
        }

        private async Task<bool> Mantra()
        {
            if (Ultima.UltSettings.BardMantra)
            {
                return await MySpells.CrossClass.Mantra.Cast();
            }
            return false;
        }

        #endregion

        #endregion

        #region Job Spells

        private async Task<bool> MagesBallad()
        {
            return await MySpells.MagesBallad.Cast();
        }

        private async Task<bool> FoeRequiem()
	{
            if (!Core.Target.HasAura(140) &&
		!Core.Player.HasAura(139) &&
		!Core.Player.HasAura(135) &&
		!Core.Player.HasAura(137) &&
		Core.Player.InCombat &&
		Helpers.EnemiesNearPlayer(20) > 0 &&
                Core.Player.TargetDistance(20, false) &&
		Ultima.LastSpell.Name != MySpells.Barrage.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.HawksEye.Name &&
		!Core.Player.HasAura(123) &&
		Ultima.LastSpell.Name != MySpells.RagingStrikes.Name &&
		!Core.Player.HasAura(125) &&
		Ultima.LastSpell.Name != MySpells.CrossClass.BloodForBlood.Name &&
		!Core.Player.HasAura(117) &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		!Core.Player.HasAura(100))
		
            {
                if (Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 3 &&
		    Core.Player.CurrentTarget.CurrentHealthPercent > 20 &&
		    Helpers.EnemiesNearPlayer(20) == 1 &&
                    Core.Player.CurrentManaPercent > 60 ||

		    Ultima.UltSettings.SingleTarget &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 2 &&
		    Core.Player.CurrentTarget.CurrentHealthPercent <= 20 &&
		    Helpers.EnemiesNearPlayer(20) == 1 &&
                    Core.Player.CurrentManaPercent > 40 ||

		    Ultima.UltSettings.SmartTarget &&
		    Core.Player.CurrentTarget.CurrentHealth >= Core.Player.MaxHealth * .7 &&
		    Helpers.EnemiesNearPlayer(20) > 1 &&
                    Core.Player.CurrentManaPercent > 40)
                {
                    return await MySpells.FoeRequiem.Cast();
		}
            }
            return false;
        }

        private async Task<bool> ArmysPaeon()
        {
            return await MySpells.ArmysPaeon.Cast();
        }

        private async Task<bool> RainOfDeath()
        {
            if (Helpers.EnemiesNearTarget(5) > 1)
            {
                return await MySpells.RainOfDeath.Cast();
            }
            return false;
        }

        private async Task<bool> BattleVoice()
        {
            if (Ultima.LastSpell.Name != MySpells.CrossClass.Invigorate.Name &&
		Ultima.LastSpell.Name != MySpells.HawksEye.Name &&
		Ultima.LastSpell.Name != MySpells.RagingStrikes.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.BloodForBlood.Name &&
		Ultima.LastSpell.Name != MySpells.CrossClass.InternalRelease.Name &&
		Ultima.LastSpell.Name != MySpells.MiserysEnd.Name &&
		Ultima.LastSpell.Name != MySpells.Sidewinder.Name &&
		Ultima.LastSpell.Name != MySpells.RainOfDeath.Name &&
		Ultima.LastSpell.Name != MySpells.Bloodletter.Name &&
		Ultima.LastSpell.Name != MySpells.RepellingShot.Name &&
		Ultima.LastSpell.Name != MySpells.BluntArrow.Name &&
		Ultima.LastSpell.Name != MySpells.FlamingArrow.Name &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 6 &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Core.Player.TargetDistance(25, false) &&
                Core.Player.CurrentManaPercent >= 40 &&
		Core.Player.HasAura(139))
                {
                    return await MySpells.BattleVoice.Cast();
                }
	    return false;
        }

        private async Task<bool> WanderersMinuet()
        {
            if (Ultima.UltSettings.BardTheWanderersMinuet)
            {
                if (!Core.Player.HasAura(865))
                {
                    return await MySpells.WanderersMinuet.Cast();
                }
            }
            return false;
        }

        private async Task<bool> EmpyrealArrow()
        {
            if (Core.Player.CurrentTarget.CurrentHealth < Core.Player.MaxHealth * 3 &&
		Core.Player.HasAura(MySpells.StraightShot.Name, true, 3250) ||

		Core.Player.CurrentTarget.CurrentHealth >= Core.Player.MaxHealth * 3 &&
		Core.Player.HasAura(MySpells.StraightShot.Name, true, 3250) &&
                Core.Player.CurrentTarget.HasAura(MySpells.VenomousBite.Name, true, 4500) &&
                Core.Player.CurrentTarget.HasAura(MySpells.Windbite.Name, true, 4500) ||

		Core.Player.HasAura(128))
            {
                if (Ultima.UltSettings.SingleTarget &&
		    Core.Player.TargetDistance(25, false) &&
		    !Actionmanager.CanCast(MySpells.RagingStrikes.Name, Core.Player) &&
		    !Actionmanager.CanCast(MySpells.HawksEye.Name, Core.Player) &&
		    !Actionmanager.CanCast(MySpells.CrossClass.BloodForBlood.Name, Core.Player) &&
		    Actionmanager.CanCast(MySpells.EmpyrealArrow.Name, Core.Player.CurrentTarget) &&
		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 3)
                {
                    if (await MySpells.Barrage.Cast())
                    {
                        await Coroutine.Wait(3000, () => Actionmanager.CanCast(MySpells.EmpyrealArrow.Name, Core.Player.CurrentTarget));
                    }
                }
                return await MySpells.EmpyrealArrow.Cast();
            }
            return false;
        }

        private async Task<bool> IronJaws()
        {
            if (Core.Player.CurrentTarget.CurrentHealthPercent > 4 &&
		Core.Player.CurrentTarget.HasAura(MySpells.VenomousBite.Name, true) &&
                Core.Player.CurrentTarget.HasAura(MySpells.Windbite.Name, true))
            {
                if (!Core.Player.CurrentTarget.HasAura(MySpells.VenomousBite.Name, true, 4500) &&
		    !Core.Player.HasAura(128) ||

                    !Core.Player.CurrentTarget.HasAura(MySpells.Windbite.Name, true, 4500) &&
		    !Core.Player.HasAura(128))
                {
                    return await MySpells.IronJaws.Cast();
                }
            }
            return false;
        }

        private async Task<bool> TheWardensPaean()
        {
            return await MySpells.TheWardensPaean.Cast();
        }

        private async Task<bool> Sidewinder()
        {
            if (Ultima.UltSettings.SingleTarget &&
		!Actionmanager.CanCast(MySpells.Barrage.Name, Core.Player) &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth &&
		Core.Player.CurrentTarget.HasAura(MySpells.VenomousBite.Name, true, 2000) &&
                Core.Player.CurrentTarget.HasAura(MySpells.Windbite.Name, true, 2000) &&
		!Actionmanager.CanCast(MySpells.RagingStrikes.Name, Core.Player) &&
		!Actionmanager.CanCast(MySpells.HawksEye.Name, Core.Player) &&
		!Actionmanager.CanCast(MySpells.CrossClass.BloodForBlood.Name, Core.Player) &&
		!Actionmanager.CanCast(MySpells.CrossClass.InternalRelease.Name, Core.Player) ||

		!Ultima.UltSettings.SingleTarget &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth &&
		Core.Player.CurrentTarget.HasAura(MySpells.VenomousBite.Name, true, 2000) &&
                Core.Player.CurrentTarget.HasAura(MySpells.Windbite.Name, true, 2000) ||

		Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth)
            {
                return await MySpells.Sidewinder.Cast();
            }
            return false;
        }

        #endregion

        #region PvP Spells

        private async Task<bool> BlastShot()
        {
            return await MySpells.PvP.BlastShot.Cast();
        }

        private async Task<bool> Farshot()
        {
            return await MySpells.PvP.Farshot.Cast();
        }

        private async Task<bool> ManaDraw()
        {
            return await MySpells.PvP.ManaDraw.Cast();
        }

        private async Task<bool> Manasong()
        {
            return await MySpells.PvP.Manasong.Cast();
        }

        private async Task<bool> Purify()
        {
            return await MySpells.PvP.Purify.Cast();
        }

        #endregion
    }
}