﻿using ff14bot;
using ff14bot.Managers;
using System.Threading.Tasks;
using UltimaCR.Spells.Main;

namespace UltimaCR.Rotations
{
    public sealed partial class Warrior
    {
        private WarriorSpells _mySpells;

        private WarriorSpells MySpells
        {
            get { return _mySpells ?? (_mySpells = new WarriorSpells()); }
        }

        #region Class Spells

        private async Task<bool> HeavySwing()
        {
            return await MySpells.HeavySwing.Cast();
        }

        private async Task<bool> Foresight()
        {
            return await MySpells.Foresight.Cast();
        }

        private async Task<bool> SkullSunder()
        {
            if (Actionmanager.LastSpell.Name == MySpells.HeavySwing.Name &&
		Core.Player.CurrentTarget.CurrentHealthPercent >= 98 &&
		!Actionmanager.HasSpell(MySpells.Defiance.Name) &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 3 &&
		Helpers.EnemiesNearPlayer(5) < 2 ||

		Actionmanager.LastSpell.Name == MySpells.HeavySwing.Name &&
		Core.Player.CurrentTarget.CurrentHealthPercent >= 98 &&
		Actionmanager.HasSpell(MySpells.Defiance.Name) &&
		Core.Player.HasAura(91) &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 3 &&
		Helpers.EnemiesNearPlayer(5) < 2 ||

		Actionmanager.LastSpell.Name == MySpells.HeavySwing.Name &&
		!Actionmanager.HasSpell(MySpells.Maim.Name) ||

		Actionmanager.LastSpell.Name == MySpells.HeavySwing.Name &&
		Actionmanager.HasSpell(MySpells.Maim.Name) &&
		!Actionmanager.HasSpell(MySpells.StormsPath.Name) &&
		Core.Player.HasAura(MySpells.Maim.Name, true, 5000) ||

		Actionmanager.LastSpell.Name == MySpells.HeavySwing.Name &&
		Actionmanager.HasSpell(MySpells.StormsPath.Name) &&
		!Actionmanager.HasSpell(MySpells.StormsEye.Name) &&
		Core.Player.HasAura(MySpells.Maim.Name, true, 5000) &&
		Core.Player.CurrentTarget.HasAura(MySpells.StormsPath.Name, false, 11500)  ||

		Actionmanager.LastSpell.Name == MySpells.HeavySwing.Name &&
		Actionmanager.HasSpell(MySpells.StormsEye.Name) &&
		Core.Player.HasAura(MySpells.Maim.Name, true, 8000) &&
		Core.Player.CurrentTarget.HasAura(MySpells.StormsPath.Name, false, 11500) &&
		Core.Player.CurrentTarget.HasAura(MySpells.StormsEye.Name, false, 11500) ||

		Actionmanager.LastSpell.Name == MySpells.HeavySwing.Name &&
		Actionmanager.HasSpell(MySpells.StormsEye.Name) &&
		Core.Player.HasAura(MySpells.Maim.Name, true, 8000) &&
		Core.Player.CurrentTarget.HasAura(MySpells.StormsPath.Name, false, 11500) &&
		Core.Player.CurrentTarget.HasAura(491))
            {
                return await MySpells.SkullSunder.Cast();
            }
            return false;
        }

        private async Task<bool> Fracture()
        {
            if (Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth / 2 &&
		!Core.Player.HasAura(86) ||
		
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth / 2 &&
		!Core.Player.HasAura(86, false, 3000))
            {
                if (Actionmanager.LastSpell.Name == MySpells.StormsEye.Name &&
		    !Core.Player.CurrentTarget.HasAura(MySpells.Fracture.Name, true, 6500) &&
		    Actionmanager.HasSpell(MySpells.StormsEye.Name)  ||

		    Actionmanager.LastSpell.Name == MySpells.ButchersBlock.Name &&
		    !Core.Player.CurrentTarget.HasAura(MySpells.Fracture.Name, true, 6500) &&
		    Actionmanager.HasSpell(MySpells.ButchersBlock.Name) &&
		    Core.Player.HasAura(MySpells.Maim.Name, false, 6000) ||

		    Actionmanager.LastSpell.Name == MySpells.StormsPath.Name &&
		    !Core.Player.CurrentTarget.HasAura(MySpells.Fracture.Name, true, 6500) &&
		    Actionmanager.HasSpell(MySpells.StormsPath.Name) &&
		    Core.Player.HasAura(MySpells.Maim.Name, false, 6000) ||

		    !Actionmanager.HasSpell(MySpells.ButchersBlock.Name) &&
		    Actionmanager.LastSpell.Name == MySpells.SkullSunder.Name &&
		    !Core.Player.CurrentTarget.HasAura(MySpells.Fracture.Name, true, 4500) ||

		    !Actionmanager.HasSpell(MySpells.ButchersBlock.Name) &&
		    Actionmanager.LastSpell.Name == MySpells.Maim.Name &&
		    !Core.Player.CurrentTarget.HasAura(MySpells.Fracture.Name, true, 4500))
                {
                    return await MySpells.Fracture.Cast();
                }
            }
            return false;
        }

        private async Task<bool> Bloodbath()
       	{
            if (Ultima.UltSettings.MultiTarget &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Core.Player.TargetDistance(4, false) &&
		Core.Player.CurrentHealthPercent <= 60)
            {
                return await MySpells.Bloodbath.Cast();
            }
            return false;
        }

        private async Task<bool> BrutalSwing()
        {
            if (Ultima.UltSettings.WarriorBrutalSwing &&
		Ultima.LastSpell.Name != MySpells.Tomahawk.Name)
            {
                if (!Actionmanager.HasSpell(MySpells.StormsEye.Name) ||

		    Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth / 4 ||

		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth / 4 &&
		    Actionmanager.HasSpell(MySpells.StormsEye.Name) &&
		    Core.Player.CurrentTarget.HasAura(MySpells.StormsEye.Name) ||

		    Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth / 4 &&
		    Core.Player.CurrentTarget.HasAura("Dancing Edge"))
                {
                    return await MySpells.BrutalSwing.Cast();
                }
            }
            return false;
        }

        private async Task<bool> Overpower()
        {
            if (!Actionmanager.HasSpell(MySpells.ButchersBlock.Name) &&
		Actionmanager.LastSpell.Name == MySpells.SkullSunder.Name &&
		Core.Player.CurrentTP > 600 &&
		Helpers.EnemiesNearPlayer(6) >= 2 ||

		!Actionmanager.HasSpell(MySpells.StormsPath.Name) &&
		Actionmanager.LastSpell.Name == MySpells.Maim.Name &&
		Core.Player.CurrentTP > 600 &&
		Helpers.EnemiesNearPlayer(6) >= 2 ||

		Actionmanager.HasSpell(MySpells.StormsPath.Name) &&
		Actionmanager.LastSpell.Name == MySpells.StormsPath.Name &&
		Core.Player.CurrentTP > 600 &&
		Helpers.EnemiesNearPlayer(6) >= 2 ||

		Actionmanager.HasSpell(MySpells.StormsEye.Name) &&
		Actionmanager.LastSpell.Name == MySpells.StormsEye.Name &&
		Core.Player.CurrentTP > 600 &&
		Helpers.EnemiesNearPlayer(6) >= 2 ||

		Actionmanager.HasSpell(MySpells.ButchersBlock.Name) &&
		Actionmanager.LastSpell.Name == MySpells.ButchersBlock.Name &&
		Core.Player.CurrentTP > 600 &&
		Helpers.EnemiesNearPlayer(6) >= 2)
            {
                return await MySpells.Overpower.Cast();
            }
            return false;
        }

        private async Task<bool> Tomahawk()
        {
            if (!Actionmanager.HasSpell(MySpells.Defiance.Name) &&
		!Core.Player.InCombat &&
		Core.Player.TargetDistance(10, false) ||

		Ultima.LastSpell.Name != MySpells.Tomahawk.Name &&
		!Actionmanager.HasSpell(MySpells.Defiance.Name) &&
		Core.Player.CurrentTarget.CurrentHealthPercent >= 99 &&
		Core.Player.TargetDistance(10) ||

		Actionmanager.HasSpell(MySpells.Defiance.Name) &&
		Core.Player.HasAura(91) &&
		!Core.Player.InCombat &&
		!Core.Player.HasAura(729) &&
		Core.Player.TargetDistance(10, false) ||

		Ultima.LastSpell.Name != MySpells.Tomahawk.Name &&
		Actionmanager.HasSpell(MySpells.Defiance.Name) &&
		Core.Player.HasAura(91) &&
		Core.Player.CurrentTarget.CurrentHealthPercent >= 99 &&
		Core.Player.TargetDistance(10))
            {
                return await MySpells.Tomahawk.Cast();
            }
            return false;
        }

        private async Task<bool> Maim()
        {
            if (Actionmanager.LastSpell.Name == MySpells.HeavySwing.Name &&
		Core.Player.CurrentTarget.CurrentHealthPercent < 98 &&
		Core.Player.HasAura(MySpells.Defiance.Name) &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 3 ||

		Actionmanager.LastSpell.Name == MySpells.HeavySwing.Name &&
		!Core.Player.HasAura(MySpells.Defiance.Name) &&
		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth * 3 ||

		Actionmanager.LastSpell.Name == MySpells.HeavySwing.Name &&
		Core.Player.CurrentTarget.CurrentHealth <= Core.Player.MaxHealth * 3)
            {
                if (!Core.Player.HasAura(MySpells.Maim.Name, false, 5000) &&
		    !Actionmanager.HasSpell(MySpells.StormsPath.Name) &&
                    !Actionmanager.HasSpell(MySpells.StormsEye.Name) ||

		    !Core.Player.HasAura(MySpells.Maim.Name, false, 5000) &&
		    Actionmanager.HasSpell(MySpells.StormsPath.Name) &&
                    !Actionmanager.HasSpell(MySpells.StormsEye.Name) ||

		    !Core.Player.CurrentTarget.HasAura(MySpells.StormsPath.Name, false, 11500) &&
		    Actionmanager.HasSpell(MySpells.StormsPath.Name) &&
                    !Actionmanager.HasSpell(MySpells.StormsEye.Name) ||

		    Actionmanager.HasSpell(MySpells.StormsPath.Name) &&
                    Actionmanager.HasSpell(MySpells.StormsEye.Name))
                {
                    return await MySpells.Maim.Cast();
                }
            }
            return false;
        }

        private async Task<bool> Berserk()
        {
            if (Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth / 3 &&
		!Core.Player.HasAura(MySpells.Defiance.Name) &&
		!Core.Player.HasAura(MySpells.Deliverance.Name) &&
		Core.Player.InCombat &&
		Core.Player.HasTarget ||

		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth / 3 &&
		Actionmanager.LastSpell.Name == MySpells.HeavySwing.Name &&
		Core.Player.HasAura(MySpells.Maim.Name, true, 5000) &&
		!Core.Player.HasAura("Defiance") &&
		Core.Player.HasAura("Abandon IV") &&
		Core.Player.InCombat &&
		Core.Player.HasTarget ||

		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth / 3 &&
		Actionmanager.LastSpell.Name == MySpells.SkullSunder.Name &&
		Core.Player.HasAura(MySpells.Maim.Name, true, 5000) &&
		!Core.Player.HasAura("Defiance") &&
		Core.Player.HasAura("Abandon IV") &&
		Core.Player.InCombat &&
		Core.Player.HasTarget ||

		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth / 3 &&
		Actionmanager.LastSpell.Name == MySpells.Maim.Name &&
		Core.Player.HasAura(MySpells.Maim.Name, true, 5000) &&
		!Core.Player.HasAura("Defiance") &&
		Core.Player.HasAura("Abandon IV") &&
		Core.Player.InCombat &&
		Core.Player.HasTarget ||



		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth / 3 &&
		Actionmanager.LastSpell.Name == MySpells.HeavySwing.Name &&
		Core.Player.HasAura(MySpells.Maim.Name, true, 5000) &&
		!Core.Player.HasAura("Defiance") &&
		Core.Player.HasAura("Uncontrollable") &&
		Core.Player.InCombat &&
		Core.Player.HasTarget ||

		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth / 3 &&
		Actionmanager.LastSpell.Name == MySpells.SkullSunder.Name &&
		Core.Player.HasAura(MySpells.Maim.Name, true, 5000) &&
		!Core.Player.HasAura("Defiance") &&
		Core.Player.HasAura("Uncontrollable") &&
		Core.Player.InCombat &&
		Core.Player.HasTarget ||

		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth / 3 &&
		Actionmanager.LastSpell.Name == MySpells.Maim.Name &&
		Core.Player.HasAura(MySpells.Maim.Name, true, 5000) &&
		!Core.Player.HasAura("Defiance") &&
		Core.Player.HasAura("Uncontrollable") &&
		Core.Player.InCombat &&
		Core.Player.HasTarget ||



		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth / 3 &&
		Core.Player.HasAura(MySpells.Maim.Name, true, 5000) &&
		Core.Player.HasAura("Defiance") &&
		Core.Player.HasAura(92) &&
		Core.Player.InCombat &&
		Core.Player.HasTarget ||

		Core.Player.CurrentTarget.CurrentHealth > Core.Player.MaxHealth / 3 &&
		Actionmanager.LastSpell.Name != MySpells.StormsPath.Name &&
		Actionmanager.LastSpell.Name != MySpells.StormsEye.Name &&
		Actionmanager.LastSpell.Name != MySpells.ButchersBlock.Name &&
		Core.Player.HasAura(MySpells.Maim.Name, true, 5000) &&
		Core.Player.HasAura("Defiance") &&
		Core.Player.HasAura(96) &&
		Core.Player.InCombat &&
		Core.Player.HasTarget)
		
            {
                if (!Actionmanager.HasSpell(MySpells.StormsEye.Name) ||
                    Actionmanager.HasSpell(MySpells.StormsEye.Name) &&
                    Core.Player.CurrentTarget.HasAura(MySpells.StormsEye.Name, false, 5000) ||
		    Core.Player.CurrentTarget.HasAura(491))
                {
                    return await MySpells.Berserk.Cast();
                }
            }
            return false;
        }

        private async Task<bool> MercyStroke()
        {
            if (Ultima.UltSettings.WarriorMercyStroke)
            {
                return await MySpells.MercyStroke.Cast();
            }
            return false;
        }

        private async Task<bool> ButchersBlock()
        {
            if (Actionmanager.LastSpell.Name == MySpells.SkullSunder.Name)
            {
                return await MySpells.ButchersBlock.Cast();
            }
            return false;
        }

        private async Task<bool> ThrillOfBattle()
        {
            return await MySpells.ThrillOfBattle.Cast();
        }

        private async Task<bool> StormsPath()
        {
            if (Actionmanager.LastSpell.Name == MySpells.Maim.Name)
            {
                if (!Actionmanager.HasSpell(MySpells.StormsEye.Name) &&
                    !Core.Player.CurrentTarget.HasAura(MySpells.StormsPath.Name, false, 11500) ||

		    !Actionmanager.HasSpell(MySpells.StormsEye.Name) &&
                    Core.Player.CurrentTarget.HasAura(MySpells.StormsPath.Name, false, 11500) ||

		    Core.Player.CurrentTarget.HasAura(491) ||

		    Actionmanager.HasSpell(MySpells.StormsEye.Name) &&
                    Core.Player.CurrentTarget.HasAura(MySpells.StormsEye.Name, false, 8000))
                {
                    return await MySpells.StormsPath.Cast();
		}
            }
            return false;
        }

        private async Task<bool> Holmgang()
        {
            return await MySpells.Holmgang.Cast();
        }

        private async Task<bool> Vengeance()
        {
	    if (!Actionmanager.HasSpell(MySpells.RawIntuition.Name) &&
		Core.Player.HasAura(729) &&
		Core.Player.HasAura(86) &&
		Core.Player.HasAura(731) ||
		!Actionmanager.HasSpell(MySpells.RawIntuition.Name) &&
		Core.Player.HasAura(729) &&
		Core.Player.HasAura(86) &&
		Core.Player.HasAura(732))
	    {
		return await MySpells.Vengeance.Cast(); 
	    }
	    return false;
	}

        private async Task<bool> StormsEye()
        {
            if (Actionmanager.LastSpell.Name == MySpells.Maim.Name &&
		!Core.Player.CurrentTarget.HasAura(MySpells.StormsEye.Name, false, 8000) ||

		Actionmanager.LastSpell.Name == MySpells.Maim.Name &&
		!Core.Player.CurrentTarget.HasAura(491))
            {
                return await MySpells.StormsEye.Cast();
            }
            return false;
        }

        #endregion

        #region Cross Class Spells

        #region Gladiator

        private async Task<bool> SavageBlade()
        {
            if (Ultima.UltSettings.WarriorSavageBlade)
            {
                return await MySpells.CrossClass.SavageBlade.Cast();
            }
            return false;
        }

        private async Task<bool> Flash()
        {
            if (Ultima.LastSpell.Name == MySpells.Tomahawk.Name &&
		Helpers.EnemiesNearPlayer(5) >= 2 ||

		!Actionmanager.HasSpell(MySpells.ButchersBlock.Name) &&
		Actionmanager.LastSpell.Name == MySpells.SkullSunder.Name &&
		Core.Player.CurrentTP <= 600 &&
		Helpers.EnemiesNearPlayer(5) >= 2 ||

		!Actionmanager.HasSpell(MySpells.StormsPath.Name) &&
		Actionmanager.LastSpell.Name == MySpells.Maim.Name &&
		Core.Player.CurrentTP <= 600 &&
		Helpers.EnemiesNearPlayer(5) >= 2 ||

		Actionmanager.HasSpell(MySpells.ButchersBlock.Name) &&
		Actionmanager.LastSpell.Name == MySpells.ButchersBlock.Name &&
		Core.Player.CurrentTP <= 600 &&
		Helpers.EnemiesNearPlayer(5) >= 2 ||

		Actionmanager.HasSpell(MySpells.StormsPath.Name) &&
		Actionmanager.LastSpell.Name == MySpells.StormsPath.Name &&
		Core.Player.CurrentTP <= 600 &&
		Helpers.EnemiesNearPlayer(5) >= 2 ||

		Actionmanager.HasSpell(MySpells.StormsEye.Name) &&
		Actionmanager.LastSpell.Name == MySpells.StormsEye.Name &&
		Core.Player.CurrentTP <= 600 &&
		Helpers.EnemiesNearPlayer(5) >= 2)
            {
                return await MySpells.CrossClass.Flash.Cast();
            }
            return false;
        }

        private async Task<bool> Convalescence()
        {
            if (Ultima.UltSettings.WarriorConvalescence)
            {
                return await MySpells.CrossClass.Convalescence.Cast();
            }
            return false;
        }

        private async Task<bool> Provoke()
        {
            if (Ultima.UltSettings.WarriorProvoke)
            {
                return await MySpells.CrossClass.Provoke.Cast();
            }
            return false;
        }

        private async Task<bool> Awareness()
        {
            if (Ultima.UltSettings.WarriorAwareness)
            {
                return await MySpells.CrossClass.Awareness.Cast();
            }
            return false;
        }

        #endregion

        #region Pugilist

        private async Task<bool> Featherfoot()
        {
            if (Ultima.UltSettings.WarriorFeatherfoot)
            {
                return await MySpells.CrossClass.Featherfoot.Cast();
            }
            return false;
        }

        private async Task<bool> SecondWind()
        {
            if (Ultima.UltSettings.WarriorSecondWind &&
		Actionmanager.HasSpell(MySpells.Equilibrium.Name) &&
		Core.Player.HasAura(91) &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Core.Player.TargetDistance(4, false) &&
		Core.Player.CurrentHealthPercent <= 25 ||

		Ultima.UltSettings.WarriorSecondWind &&
		Actionmanager.HasSpell(MySpells.Equilibrium.Name) &&
		!Core.Player.HasAura(91) &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Core.Player.TargetDistance(4, false) &&
		Core.Player.CurrentHealthPercent <= 50 ||

		Ultima.UltSettings.WarriorSecondWind &&
		!Actionmanager.HasSpell(MySpells.Equilibrium.Name) &&
		Core.Player.HasAura(91) &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Core.Player.TargetDistance(4, false) &&
		Core.Player.CurrentHealthPercent <= 25 ||

		Ultima.UltSettings.WarriorSecondWind &&
		!Actionmanager.HasSpell(MySpells.Equilibrium.Name) &&
		!Core.Player.HasAura(91) &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Core.Player.TargetDistance(4, false) &&
		Core.Player.CurrentHealthPercent <= 50)
            {
                return await MySpells.CrossClass.SecondWind.Cast();
            }
            return false;
        }

        private async Task<bool> Haymaker()
        {
            if (Ultima.UltSettings.WarriorHaymaker)
            {
                return await MySpells.CrossClass.Haymaker.Cast();
            }
            return false;
        }

        private async Task<bool> InternalRelease()
        {
            if (Ultima.UltSettings.WarriorInternalRelease &&
		!Core.Player.HasAura(MySpells.Defiance.Name) &&
		!Core.Player.HasAura(MySpells.Deliverance.Name) &&
		Core.Player.InCombat &&
		Core.Player.HasTarget &&
		Core.Player.TargetDistance(1-5) ||

		Ultima.UltSettings.WarriorInternalRelease &&
		!Core.Player.HasAura("Defiance") &&
		Core.Player.HasAura(732) &&
		Core.Player.InCombat &&
		Core.Player.HasTarget &&
		Core.Player.TargetDistance(1-5) ||

		Ultima.UltSettings.WarriorInternalRelease &&
		!Core.Player.HasAura("Defiance") &&
		!Actionmanager.CanCast(MySpells.Berserk.Name, Core.Player) &&
		Core.Player.InCombat &&
		Core.Player.HasTarget &&
		Core.Player.TargetDistance(1-5) ||

		Ultima.UltSettings.WarriorInternalRelease &&
		Core.Player.HasAura("Defiance") &&
		Core.Player.HasAura(95) &&
		Core.Player.InCombat &&
		Core.Player.HasTarget &&
		Core.Player.TargetDistance(1-5)) 
            {
                return await MySpells.CrossClass.InternalRelease.Cast();
            }
            return false;
        }

        private async Task<bool> Mantra()
        {
            if (Ultima.UltSettings.WarriorMantra)
            {
                return await MySpells.CrossClass.Mantra.Cast();
            }
            return false;
        }

        #endregion

        #endregion

        #region Job Spells

        private async Task<bool> Defiance()
        {
			if (!Core.Player.HasAura("Defiance") && !Core.Player.HasAura("Deliverance"))
            {
            return await MySpells.Defiance.Cast();
			}
			return false;
        }

        private async Task<bool> InnerBeast()
        {
	    if (!Actionmanager.CanCast(MySpells.Unchained.Name, Core.Player) &&
		Core.Player.HasAura(MySpells.Maim.Name, true, 5000) &&
		!Core.Player.HasAura(411))
		
	    {
		return await MySpells.InnerBeast.Cast(); 
	    }
	    return false;
	}

        private async Task<bool> Unchained()
        {
	    if (Core.Player.HasAura(91) &&
		Core.Player.HasAura(97) &&
		Actionmanager.CanCast(MySpells.Unchained.Name, Core.Player))
            {
                return await MySpells.Unchained.Cast();
            }
	    return false;
        }

        private async Task<bool> SteelCyclone()
        {
			if (Helpers.EnemiesNearPlayer(5) > 2)
					{
						return await MySpells.SteelCyclone.Cast(); 
					}
					return false;
        }

        private async Task<bool> Infuriate()
        {
	    if (Core.Player.HasAura(MySpells.Maim.Name, true, 5000) &&
		!Core.Player.HasAura("Abandon") &&
		!Core.Player.HasAura("Abandon II") &&
		!Core.Player.HasAura("Abandon III") && 
		!Core.Player.HasAura("Abandon IV") && 
		!Core.Player.HasAura("Uncontrollable") && 
		!Core.Player.HasAura("Wrath") &&
		!Core.Player.HasAura("Wrath II") &&
		!Core.Player.HasAura("Wrath III") &&
		!Core.Player.HasAura("Wrath IV") && 
		!Core.Player.HasAura("Infuriated"))
            {
		return await MySpells.Infuriate.Cast();
	    }
	    return false;
        }

        private async Task<bool> Deliverance()
        {
	    if (!Core.Player.HasAura("Defiance") &&
		!Core.Player.HasAura("Deliverance"))
            {
                return await MySpells.Deliverance.Cast();
            }
	    return false;
        }

        private async Task<bool> FellCleave()
	{
            if (!Actionmanager.CanCast(MySpells.Berserk.Name, Core.Player) &&
		Core.Player.HasAura(MySpells.Maim.Name, true, 5000))
            {
                if (!Core.Player.HasAura(86) &&
		    Actionmanager.LastSpell.Name != MySpells.StormsEye.Name &&
		    Actionmanager.LastSpell.Name != MySpells.StormsPath.Name &&
		    Actionmanager.LastSpell.Name != MySpells.ButchersBlock.Name &&
		    Core.Player.HasAura(734) ||

		    Core.Player.HasAura(86) &&
		    Core.Player.HasAura(734))
                {
                    return await MySpells.FellCleave.Cast();
		}
            }
            return false;
        }

        private async Task<bool> RawIntuition()
        {
	    if (Core.Player.HasAura(729) &&
		Core.Player.HasAura(86) &&
		Core.Player.HasAura(731) ||
		Core.Player.HasAura(729) &&
		Core.Player.HasAura(86) &&
		Core.Player.HasAura(732) ||
		Core.Player.HasAura(91) &&
		Core.Player.HasAura(86) &&
		Core.Player.HasAura(95) ||
		Core.Player.HasAura(91) &&
		Core.Player.HasAura(86) &&
		Core.Player.HasAura(96))
	    {
		return await MySpells.RawIntuition.Cast(); 
	    }
	    return false;
	}

        private async Task<bool> Equilibrium()
        {
            if (Core.Player.HasAura(91) &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Core.Player.TargetDistance(4, false) &&
		Core.Player.CurrentHealthPercent <= 50 ||

		Core.Player.HasAura(729) &&
		Core.Player.HasTarget &&
		Core.Player.InCombat &&
		Core.Player.TargetDistance(4, false) &&
		Core.Player.CurrentTP <= 670)
            {
                return await MySpells.Equilibrium.Cast();
            }
            return false;
        }

        private async Task<bool> Decimate()
        {
            if (Core.Player.HasAura(MySpells.Maim.Name, true, 5000) && Ultima.UltSettings.SmartTarget &&
            Helpers.EnemiesNearTarget(5) > 3 ||
            Ultima.UltSettings.MultiTarget && Core.Player.HasAura(MySpells.Maim.Name, true, 5000))
			{
			return await MySpells.Decimate.Cast(); 
			}
			return false;
        }

        #endregion

        #region PvP Spells

        private async Task<bool> FullSwing()
        {
            return await MySpells.PvP.FullSwing.Cast();
        }

        private async Task<bool> MythrilTempest()
        {
            return await MySpells.PvP.MythrilTempest.Cast();
        }

        private async Task<bool> Purify()
        {
            return await MySpells.PvP.Purify.Cast();
        }

        private async Task<bool> ThrillOfWar()
        {
            return await MySpells.PvP.ThrillOfWar.Cast();
        }

        #endregion
    }
}